package com.sf.rocketmq;

package ..deTemp.1744120008920;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.datahub.client.exception.DatahubClientException;
import com.aliyun.datahub.client.exception.InvalidParameterException;
import com.aliyun.datahub.client.exception.MalformedRecordException;
import com.aliyun.datahub.client.exception.ResourceNotFoundException;
import com.aliyun.datahub.client.model.Field;
import com.aliyun.datahub.client.model.FieldType;
import com.aliyun.datahub.client.model.RecordData;
import com.aliyun.datahub.client.model.RecordEntry;
import com.aliyun.datahub.client.model.RecordSchema;
import com.aliyun.datahub.client.model.TupleRecordData;
import com.aliyun.datahub.clientlibrary.config.ProducerConfig;
import com.aliyun.datahub.clientlibrary.producer.Producer;
import com.sf.msg.adapter.BaseQueueTaskThread;
import com.sf.rocketmq.api.ConfigReadAPI;
import com.smartframework.web.core.utils.ParameterUtils;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;
import org.apache.log4j.Logger;

public class ZhongtaiDataHubSdkHandler extends BaseQueueTaskThread {
  static Logger logger = Logger.getLogger(com.sf.rocketmq.ZhongtaiDataHubSdkHandler.class);
  
  static com.sf.rocketmq.ZhongtaiDataHubSdkHandler zhongtaiDataHubSdkHandler;
  
  public static com.sf.rocketmq.ZhongtaiDataHubSdkHandler getInstance() {
    logger.info("进入消息队列处理");
    if (zhongtaiDataHubSdkHandler == null) {
      zhongtaiDataHubSdkHandler = new com.sf.rocketmq.ZhongtaiDataHubSdkHandler();
      zhongtaiDataHubSdkHandler.start();
    } 
    return zhongtaiDataHubSdkHandler;
  }
  
  public void handleData(Object o) {
    logger.info("进入handleData()");
    JSONObject jSONObject = JSONObject.parseObject(JSON.toJSONString(o));
    for (String topic : jSONObject.keySet()) {
      logger.info(String.format("topic = %s", new Object[] { topic }));
      sendMsg(topic, jSONObject.get(topic).toString());
    } 
  }
  
  private void tupleExample(String topic, String sendMsg) {
    logger.info("进入tupleExample函数\n");
    if (ParameterUtils.isEmptyOrNull(ConfigReadAPI.sdkEndpoint()) || ParameterUtils.isEmptyOrNull(ConfigReadAPI.sdkAccessId()) || ParameterUtils.isEmptyOrNull(ConfigReadAPI.sdkAccessKey())) {
      logger.error("datahub相关配置文件获取失败，请检查配置文件");
      return;
    } 
    ProducerConfig producerConfig = new ProducerConfig(ConfigReadAPI.sdkEndpoint(), ConfigReadAPI.sdkAccessId(), ConfigReadAPI.sdkAccessKey());
    Producer producer = new Producer(ConfigReadAPI.projectName(), topic, producerConfig);
    List<RecordEntry> recordEntries = new ArrayList<>();
    RecordSchema schema = new RecordSchema();
    schema.addField(new Field("data", FieldType.STRING));
    RecordEntry entry = new RecordEntry();
    TupleRecordData data = new TupleRecordData(schema);
    data.setField("data", sendMsg);
    entry.setRecordData((RecordData)data);
    recordEntries.add(entry);
    logger.info(String.format("%s主题消息开始发送", new Object[] { topic }));
    sendRecords(producer, recordEntries);
  }
  
  private void sendMsg(String sendTopic, String messageData) {
    logger.info("进入sendMsg");
    if (ParameterUtils.isEmptyOrNull(messageData)) {
      logger.error("消息为空，不发送");
      return;
    } 
    tupleExample(sendTopic, messageData);
  }
  
  private static void sendRecords(Producer producer, List<RecordEntry> recordEntries) {
    int maxRetry = 3;
    while (true) {
      try {
        producer.send(recordEntries, maxRetry);
        logger.info("send records:" + recordEntries.size());
        break;
      } catch (MalformedRecordException e) {
        logger.error("write fail", (Throwable)e);
        throw e;
      } catch (InvalidParameterException|com.aliyun.datahub.client.exception.AuthorizationFailureException|com.aliyun.datahub.client.exception.NoPermissionException e) {
        logger.error("write fail", (Throwable)e);
        throw e;
      } catch (ResourceNotFoundException e) {
        logger.error("write fail", (Throwable)e);
        throw e;
      } catch (DatahubClientException e) {
        logger.error("write fail", (Throwable)e);
        sleep(1000L);
      } 
    } 
  }
  
  public static void sleep(long milliSeconds) {
    try {
      TimeUnit.MILLISECONDS.sleep(milliSeconds);
    } catch (InterruptedException interruptedException) {}
  }
}
